Loading...
Searching...
No Matches
pcl::StatisticalMultiscaleInterestRegionExtraction< PointT > Class Template Reference

Class for extracting interest regions from unstructured point clouds, based on a multi scale statistical approach. More...

`#include <pcl/features/statistical_multiscale_interest_region_extraction.h>`

Inheritance diagram for pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >:

## Public Types

using | IndicesPtr = shared_ptr<pcl::Indices >
using | Ptr = shared_ptr<StatisticalMultiscaleInterestRegionExtraction<PointT> >
using | ConstPtr = shared_ptr<const StatisticalMultiscaleInterestRegionExtraction<PointT> >
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| StatisticalMultiscaleInterestRegionExtraction ()=default
| Empty constructor.
void | generateCloudGraph ()
| Method that generates the underlying nearest neighbor graph based on the input point cloud.
void | computeRegionsOfInterest (std::list< IndicesPtr > &rois)
| The method to be called in order to run the algorithm and produce the resulting set of regions of interest.
void | setScalesVector (std::vector< float > &scale_values)
| Method for setting the scale parameters for the algorithm.
std::vector< float > | getScalesVector ()
| Method for getting the scale parameters vector.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Additional Inherited Members

Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT>
class pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >

Class for extracting interest regions from unstructured point clouds, based on a multi scale statistical approach.

Please refer to the following publications for more details: Ranjith Unnikrishnan and Martial Hebert Multi-Scale Interest Regions from Unorganized Point Clouds Workshop on Search in 3D (S3D), IEEE Conf. on Computer Vision and Pattern Recognition (CVPR) June, 2008

Statistical Approaches to Multi-scale Point Cloud Processing Ranjith Unnikrishnan PhD Thesis The Robotics Institute Carnegie Mellon University May, 2008

Author
  Alexandru-Eugen Ichim

Definition at line 64 of file statistical_multiscale_interest_region_extraction.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

using pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::ConstPtr = shared_ptr<const StatisticalMultiscaleInterestRegionExtraction<PointT> >

Definition at line 69 of file statistical_multiscale_interest_region_extraction.h.

## IndicesPtr

template<typename PointT>

using pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::IndicesPtr = shared_ptr<pcl::Indices >

Definition at line 67 of file statistical_multiscale_interest_region_extraction.h.

## Ptr

template<typename PointT>

using pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::Ptr = shared_ptr<StatisticalMultiscaleInterestRegionExtraction<PointT> >

Definition at line 68 of file statistical_multiscale_interest_region_extraction.h.

## Constructor & Destructor Documentation

## StatisticalMultiscaleInterestRegionExtraction()

template<typename PointT>

pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::StatisticalMultiscaleInterestRegionExtraction | ( |  | ) |

default

Empty constructor.

## Member Function Documentation

## computeRegionsOfInterest()

template<typename PointT>

void pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::computeRegionsOfInterest | ( | std::list< IndicesPtr > & | rois | ) |

The method to be called in order to run the algorithm and produce the resulting set of regions of interest.

Definition at line 122 of file statistical_multiscale_interest_region_extraction.hpp.

References generateCloudGraph().

## generateCloudGraph()

template<typename PointT>

void pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::generateCloudGraph | ( |  | ) |

Method that generates the underlying nearest neighbor graph based on the input point cloud.

Definition at line 53 of file statistical_multiscale_interest_region_extraction.hpp.

References pcl::PCLBase< PointT >::input_, pcl::KdTreeFLANN< PointT, Dist >::nearestKSearch(), and pcl::KdTreeFLANN< PointT, Dist >::setInputCloud().

Referenced by computeRegionsOfInterest().

## getScalesVector()

template<typename PointT>

std::vector< float > pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::getScalesVector | ( |  | ) |

inline

Method for getting the scale parameters vector.

Definition at line 95 of file statistical_multiscale_interest_region_extraction.h.

## setScalesVector()

template<typename PointT>

void pcl::StatisticalMultiscaleInterestRegionExtraction< PointT >::setScalesVector | ( | std::vector< float > & | scale_values | ) |

inline

Method for setting the scale parameters for the algorithm.

Parameters

  scale_values | vector of scales to determine the size of each scaling step

Definition at line 91 of file statistical_multiscale_interest_region_extraction.h.

The documentation for this class was generated from the following files:

- pcl/features/statistical_multiscale_interest_region_extraction.h
- pcl/features/impl/statistical_multiscale_interest_region_extraction.hpp